import os
import subprocess
import atexit

class MD5TOC:
    def __init__(self, fd):
        self.more = True
        def read_entry():
            data = b''
            while True:
                if not b'\n' in data:
                    tmp = fd.read(4096)
                    if len(tmp) == 0:
                        raise Exception('Premature end of file')
                    data += tmp
                    continue
                l,data = data.split(b'\n', 1)
                if l.startswith(b'#fields:'):
                    self.labels = list(map(lambda s: s.strip().decode(),
                                           l.split(b':')[1:]))
                elif l.startswith(b'#endTOC'):
                    for k in self.labels:
                        setattr(self, k, None)
                    break
                elif l.startswith(b'#'):
                    pass
                else:
                    result = list(zip(self.labels,
                                      l.split(b':', len(self.labels) - 1)))
                    for k,v in result:
                        setattr(self, k, v)
                    yield result
            while True:
                self.more = False
                yield None
            
        self.read_entry = read_entry()
        self.next()

    def next(self):
        try:
            return self.read_entry.__next__()
        except AttributeError:
            return self.read_entry.next()


    def __repr__(self):
        return 'MD5TOC(%s)' % ",".join(map(lambda k: "%s=%s" %
                                           (k, getattr(self, k)),
                                           self.labels))
